package com.jkcredit.info.query.util;

import com.jkcredit.info.query.constant.CommonConstant;
import lombok.extern.slf4j.Slf4j;
import okhttp3.Cookie;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.concurrent.ConcurrentHashMap;

@Component
@Slf4j
public class CookieUtil {
    private static String cookieUrl;
    private static String authenticationCookieUrl;

    @Value("${supplier.cookieUrl}")
    public void setCookieUrl(String cookieUrl) {
        CookieUtil.cookieUrl = cookieUrl;
    }

    @Value("${supplier.authenticationCookieUrl}")
    public void setAuthenticationCookieUrl(String authenticationCookieUrl) {
        CookieUtil.authenticationCookieUrl = authenticationCookieUrl;
    }

    public static String getAuthenticationCookie() {
        ConcurrentHashMap<String, List<Cookie>> cookieStore = CookieConcurrentHashMapUtil.getInstance();
        if (cookieStore.get(CommonConstant.COOKIE) != null) {
            return getCookie();
        }
        if (StringUtils.isNotBlank(HttpUtil.doGetLoadCookie(cookieUrl))) {
            HttpUtil.doGet(authenticationCookieUrl, getCookie());
        }
        ;
        return getCookie();
    }

    public static String getNewCookie() {
        String responseContext = HttpUtil.doGetLoadCookie(cookieUrl);
        log.info("getNewCookie:{}", responseContext);
        if (StringUtils.isNotBlank(responseContext)) {
            HttpUtil.doGet(authenticationCookieUrl, getCookie());
            return getCookie();
        } else {
            return "";
        }
    }

    public static String getCookie() {
        String cookie = "";
        ConcurrentHashMap<String, List<Cookie>> cookieStore = CookieConcurrentHashMapUtil.getInstance();
        if (cookieStore.get(CommonConstant.COOKIE) != null) {
            cookie = cookieStore.get(CommonConstant.COOKIE).get(0).name()
                    + "=" + cookieStore.get(CommonConstant.COOKIE).get(0).value();
        }
        return cookie;
    }
}
